/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef RAMFS_H
#define RAMFS_H

#include <fs/fs.h>
#include <fs/inode.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stddef.h>

struct ramfs *ramfs_mount(const struct fs_mount *m, struct fs_ret *r);
int ramfs_mkdir(const struct fs_mkdir *m, struct ramfs *rfs,
    const union inode_result *i, struct fs_ret *r);
int ramfs_open(const struct fs_open *o, struct inode *i, struct fs_ret *r);
int ramfs_read(const struct fs_read *r, struct fs_ret *ret);
int ramfs_write(const struct fs_write *w, struct fs_ret *r);
int ramfs_stat(const struct fs_stat *s, const struct ramfs *rfs,
    const union inode_result *inode, struct fs_ret *r);
int ramfs_close(struct fs_fd *fd);
int ramfs_search(const char *path, const struct ramfs *rfs,
    union inode_result *inode, struct fs_ret *r);
int ramfs_flags(const union inode_result *i);
int ramfs_mknod(const char *node, mode_t mode, dev_t dev, struct ramfs *rfs);
void ramfs_free(struct ramfs *rfs);

#endif
